package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.net.Socket;
import   java.net.UnknownHostException;
import   java.io.IOException;
import   java.net.InetAddress;
import   java.io.InputStream;
import   java.io.BufferedInputStream;

public class BufferedSocketReader
{
   public static void main(String[] args)
   {
      if( args.length < 2 )
      {
         System.err.println( "java portScanner <hostname> <port-no>" );
         System.exit( 0 );
      }

      try
      {
         InetAddress hostName = InetAddress.getByName( args[0] );
         int portNo = Integer.parseInt( args[1] );

         System.out.println( "Looking on port: " + portNo + " of: " + hostName );
         Socket connection = null;
         try
         {
            connection = new Socket( hostName, portNo );
            System.out.println( "Service running on port: " + portNo + " of: " + hostName );
            byte[] tempBuff = new byte[1024];
            int bytesRead = 0;
            int bytesToRead = 1024;
            InputStream istream = new BufferedInputStream( connection.getInputStream() );

            bytesRead = istream.read( tempBuff, bytesRead, (bytesToRead - bytesRead) );
            /*do{
               int result = istream.read( tempBuff, bytesRead, (bytesToRead - bytesRead) );
               if( result > 0 )
                  bytesRead += result;
            }while( istream.available() > 0 );*/
            if( bytesRead > 0 )
            {
               String msg = new String( tempBuff, 0, bytesRead );
               System.out.println( msg );
            }
         }
         catch( IOException e ){}
         finally
         {
            try
            {
               if( connection != null )connection.close();
            }
            catch( IOException e ){}
         }
      }
      catch( UnknownHostException e )
      {
         System.err.println( e );
      }
   }
}