package s2s.javacourse;

import java.io.*;
import java.net.*;
import java.util.*;

public class EchoServer implements Runnable 
{
	private int mPort = 0;
	private String mHost = null;
	
	private boolean mActive = true;
	
	public static void main(String[] args) 
   {
		try 
      {
			EchoServer s = new EchoServer(null, 8472);
			System.out.println("Ready ...");

		}
		catch (Exception e) 
      {
			e.printStackTrace();
		}
	}
   
	public EchoServer(String host, int port) 
   {
		mHost = host;
		mPort = port;
		
		start();
	}	
	
	public void start() 
   {
		new Thread(this).start();
	}
	
	public void run() 
   {
		try 
      {
			ServerSocket server = new ServerSocket(mPort);
			while (isActive()) 
         {
				Socket client = server.accept();
            System.out.println("Connection accepted from " + client.getLocalAddress());

            Thread clientThread = new Thread( new EchoServer.ClientHandler( client ));
            
            clientThread.start();
         }
		}
		catch (Exception e) 
      {
			e.printStackTrace();
		}
	}
	
	private boolean isActive() 
   {
		return mActive;
	}
   
   class ClientHandler implements Runnable
   {
      boolean mActive = true;
      Socket itsClient = null;
      
      ClientHandler( Socket client )
      {
         itsClient = client;
      }
      
      private boolean isActive() 
      {
         return mActive;
      }

      public void run()
      {
         try
         {
            while (isActive()) 
            {
               String msg = "";
               DataInputStream dis = new DataInputStream(itsClient.getInputStream());
               DataOutputStream dos = new DataOutputStream(itsClient.getOutputStream());

               do
               {
                  msg = dis.readUTF();

                  if( ! msg.equalsIgnoreCase( "quit" ) )
                  {
                     System.out.println( msg );

                     dos.writeUTF( msg );
                  }
               }while( ! msg.equalsIgnoreCase( "quit" ) );

               itsClient.close();
               mActive = false;
            }
         }
         catch (Exception e) 
         {
            e.printStackTrace();
         }
      }
      
   }

}
