package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.net.Socket;
import   java.net.UnknownHostException;
import   java.io.IOException;
import   java.net.InetAddress;
import   java.io.OutputStream;
import   java.io.BufferedOutputStream;
import   java.io.BufferedReader;
import   java.io.InputStreamReader;

public class ImprovedSocketWriter
{
   public static void main(String[] args)
   {
      if( args.length < 2 )
      {
         System.err.println( "java SocketWriter <hostname> <port-no>" );
         System.exit( 0 );
      }

      try
      {
         InetAddress hostName = InetAddress.getByName( args[0] );
         int portNo = Integer.parseInt( args[1] );

         System.out.println( "Looking on port: " + portNo + " of: " + hostName );
         Socket connection = null;
         try
         {
            connection = new Socket( hostName, portNo );
            System.out.println( "Service running on port: " + portNo + " of: " + hostName );
            System.out.print( "Enter text:" );
            BufferedReader reader = new BufferedReader( new InputStreamReader( System.in ) );
            String msg = reader.readLine();
            OutputStream ostream = connection.getOutputStream();

            ostream.write( msg.getBytes() );
         }
         catch( IOException e ){}
         finally
         {
            try
            {
               if( connection != null )connection.close();
            }
            catch( IOException e ){}
         }
      }
      catch( UnknownHostException e )
      {
         System.err.println( e );
      }
   }
}