package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.net.Socket;
import   java.net.UnknownHostException;
import   java.io.IOException;
import   java.net.InetAddress;

public class PortScannerImproved
{
   public static void main(String[] args)
   {
      if( args.length < 3 )
      {
         System.err.println( "java PortScannerImproved <hostname> <lower-port-no> <upper-port-no>" );
         System.exit( 0 );
      }

      try
      {
         InetAddress hostName = InetAddress.getByName( args[0] );
         int lowerPortNo = Integer.parseInt( args[1] );
         int upperPortNo = Integer.parseInt( args[2] );

         for( int i = lowerPortNo; i < upperPortNo; i++ )
         {
            System.out.println( "Looking on port: " + i + " of: " + hostName );
            Socket connection = null;
            try
            {
               connection = new Socket( hostName, i );
               System.out.println( "Service running on port: " + i + " of: " + hostName );
            }
            catch( IOException e )
            {
                System.out.println( "Cannot attach to Service running on port: " + i + " of: " + hostName );                      
            }
            finally
            {
               try
               {
                   if( connection != null )connection.close();
               }
               catch( IOException e ){}
            }
         }
      }
      catch( UnknownHostException e )
      {
         System.err.println( e );
      }
   }
}