package s2s.javacourse;

import java.io.*;
import java.net.*;
import java.util.*;

public class SimpleEchoServer implements Runnable 
{
	private int mPort = 0;
	private String mHost = null;
	
	private boolean mActive = true;
	
	public SimpleEchoServer(String host, int port) 
   {
		mHost = host;
		mPort = port;
		
		start();
	}	
	
	public void start() 
   {
		new Thread(this).start();
	}
	
	public void run() 
   {
		try 
      {
			ServerSocket server = new ServerSocket(mPort);
			while (isActive()) 
         {
				Socket client = server.accept();
            System.out.println("Connection accepted from " + client.getLocalAddress());

            String msg = "";
            
            DataInputStream din = new DataInputStream(client.getInputStream());
            DataOutputStream dos = new DataOutputStream(client.getOutputStream());

            do
            {
               msg = din.readUTF();

               if( ! msg.equalsIgnoreCase( "quit" ) )
               {
                  System.out.println( msg );

                  dos.writeUTF( msg );
               }
            }while( ! msg.equalsIgnoreCase( "quit" ) );
            
            client.close();
			}
		}
		catch (Exception e) 
      {
			e.printStackTrace();
		}
	}
	
	private boolean isActive() 
   {
		return mActive;
	}
	
	public static void main(String[] args) 
   {
		try 
      {
			SimpleEchoServer s = new SimpleEchoServer(null, 10000);
			System.out.println("Ready ...");
		}
		catch (Exception e) 
      {
			e.printStackTrace();
		}
	}
}
