package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import java.net.*;
import java.io.*;
import java.util.Date;

public class SimpleServer
{
   public final static int DEFAULT_PORT = 8091;
   public static int itsPort = DEFAULT_PORT;

   static   protected   boolean  verifyArgs( String[] args )
   {
      if (args.length > 0)
      {
         try
         {
            itsPort = Integer.parseInt(args[0]);
            if (itsPort < 0 || itsPort >= 65536)
            {
               System.out.println("Port must between 0 and 65535");
               return false;
            }
         }
         catch (NumberFormatException e){ /* use default port */ }
      }
      return true;
   }

   protected  void  runServer()
   {
      try
      {
         ServerSocket server = new ServerSocket( itsPort );
         Socket connection = null;

         while (true)
         {
            try
            {
               connection = server.accept();
               OutputStreamWriter ostream = new OutputStreamWriter(connection.getOutputStream());
               Date dt = new Date();
               ostream.write( dt.toString() +"\r\n" );
               ostream.flush();
               connection.close();
            }
            catch (IOException e) {}
            finally
            {  // always close any open connections, do not simply
               // null a reference for the object to garbage collected, the
               // socket will not be closed...
               try
               {
                  if (connection != null) connection.close();
               }
               catch (IOException e)
               {
                  // this can be ignored.  It means the client closed before
                  // we closed the socket...
               }
            }
         }  // end while
      }  // end try
      catch (IOException e)
      {  // this is to catch the ServerSocket constructor...
         System.err.println(e);
      } // end catch
   } // end runServer

   public static void main(String[] args)
   {
      if( verifyArgs( args ) )
      {
         SimpleServer server = new SimpleServer();
         server.runServer();
      }
   }
} // end DaytimeServer
