package s2s.javacourse;

import java.io.*;
import java.util.zip.*;

public class Trade implements Serializable {
	private String mTradeId = null;
	public Trade(String tradeId) {
		mTradeId = tradeId;
	}
	public String toString() {
		return mTradeId;
	}
	public static void main(String[] args) {
		
		// Serialise Trade to "trade.dat"
		
		try {
			Trade trade = new Trade("123456L");
			FileOutputStream fostream = new FileOutputStream("trade.dat");
			GZIPOutputStream gzostream = new GZIPOutputStream(fostream);
			ObjectOutputStream oostream = new ObjectOutputStream(gzostream);
			oostream.writeObject(trade);
			oostream.flush();
			oostream.close();
		}
		catch (Exception e) {	
			e.printStackTrace();
		}
		
		// Recreate Trade from the serialised data in "trade.dat"
		
		try {
			FileInputStream fistream = new FileInputStream("trade.dat");
			GZIPInputStream gzistream = new GZIPInputStream(fistream);
			ObjectInputStream oistream = new ObjectInputStream(gzistream);
			Trade t = (Trade)oistream.readObject();
			System.out.println("Trade=" + t);
			oistream.close();
		}
		catch (Exception e) {	
			e.printStackTrace();
		}		
	}	
}
