package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.util.Vector;

import   java.awt.Container;

public class WaitAndNotify
{
   private  boolean  jobCompleted = false;
   private  Vector   db = new Vector();
   private  DispatcherThread  dispatcher = new DispatcherThread();
   private  WorkerThread worker = new WorkerThread();

   private  class WorkerThread   extends  Thread
   {
      public   void  run()
      {
         WaitAndNotify.this.updateDB();
      }
   }

   private  class DispatcherThread   extends  Thread
   {
      public   void  run()
      {
         WaitAndNotify.this.dispatchResults();
      }
   }

   private  synchronized   void  updateDB()
   {
      for( int i = 0; i < 10; i++ )
      {
         db.addElement( "Handler One" + i );
      }
      jobCompleted = true;
   }

   private  synchronized   void  dispatchResults()
   {
      while( ! jobCompleted )
      {
        ;
      }
      jobCompleted = false;
      int length = db.size();

      for( int i = 0; i < length; i++ )
      {
         String val = (String)db.elementAt(  i );
         System.out.println( val );
      }
   }

   private  void  execute()
   {
       // if the program doesn't run, try swapping these lines???
      dispatcher.start();
      worker.start();
   }

   public static void main(String[] args)
   {
      WaitAndNotify waitAndNotify1 = new WaitAndNotify();

      waitAndNotify1.execute();
   }
}