package s2s.javacourse;



/**
 * Title:        Java Courseware
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      TROy Software Development
 * @author Selvyn Wright
 * @version 1.0
 */

import   java.io.FileReader;
import   java.io.IOException;
import   java.text.Collator;
import   java.util.Locale;

public class WordCountViaCharArray
{
   static char[] NewLine;

   static
   {
      String NewLineStr = System.getProperty("line.separator");
      NewLine = new char[NewLineStr.length()];
      NewLineStr.getChars(0, NewLine.length, NewLine, 0);
   }

   public static void main(String[] args)
   {
      try
      {
         long  time = System.currentTimeMillis();
         int count = 0;
         FileReader rdr = new FileReader( args[0] );
         char[] buf = new char[8192];
         int len;
         int idx = 0;
         char c = ' ';
         while( (len = rdr.read(buf, 0, buf.length)) != -1)
         {
            idx = 0;
            int start;
            //if we are already in a word, then skip the rest of it
            if (Character.isLetterOrDigit(c))
               while( (idx < len) && Character.isLetterOrDigit(buf[idx]) )
               {
                  idx++;
               }

            while(idx < len)
            {
               //skip non alphanumeric
               while( (idx < len) && !Character.isLetterOrDigit(buf[idx]) )
               {
                  idx++;
               }
               //skip word
               start = idx;
               while( (idx < len) && Character.isLetterOrDigit(buf[idx]) )
               {
                  idx++;
               }
               if (start < len)
               {
                  count++; //count word
               }
            }
            c = buf[idx-1]; //get last character so we know whether to carry on a word
         }
         System.out.println(count + " words found.");
         time = System.currentTimeMillis() - time;
         System.out.println("cwordcount time (millis) = " + time);
      }
      catch(IOException e)
      {
         System.out.println( e );
      }
   }
}