/*
 * ChatServer.java
 *
 * Created on 26 September 2003, 09:05
 */

/*
 *  This basic server will wait for connections and spawn a new ChatClientHandler
 *  for each new client connection.  It will not remember the connections so it
 *  cannot close them all if it should be closed...
 */

package stream2stream.chatComms.stage1;

import  java.lang.Thread;
import  java.lang.Runnable;
import  java.net.*;
import  java.io.*;

/**
 *
 * @author  Administrator
 */
public class ChatServerHandler implements  Runnable
{
	private int itsPort = 0;
	private String itsHost = null;
   private ServerSocket itsServerSocket = null;
   private Object blocker = new Object();
   private Thread itsThread = null;
   private boolean is_Active = true;


    /** Creates a new instance of ChatServer */
    public ChatServerHandler(String host, int port)
    {
		itsHost = host;
		itsPort = port;
    }

	public void start()
   {
      if( itsThread == null )
		   itsThread = new Thread( this );

      itsThread.start();
	}

   public void run()
   {
      setActiveState( true );

		try
      {
         System.out.println( "Start server on: " + itsPort );
         itsServerSocket = new ServerSocket( itsPort );
         itsServerSocket.setSoTimeout( 3000 );

			while (getActiveState())
         {
            try
            {
				   Socket client = itsServerSocket.accept();
				   System.out.println("Connection accepted from " + client.getLocalAddress());

               Thread newThread = new Thread( new ChatClientHandler( client ) );

               newThread.start();
            }
            catch( IOException e )
            {
               System.out.println( "Socket timed out!" );  // The chances are it timed out...
            }
			}
		}
		catch (IOException e)
      {
         // do nothing, if accept fails, chances are the socker has been closed...
			e.printStackTrace();
		}
      finally
      {
         try
         {
            if( itsServerSocket != null )
            {
               itsServerSocket.close();
               itsServerSocket = null;
               itsThread = null;
            }
         }
         catch( IOException e )
         {
            e.printStackTrace();
         }
      }
	}

	public void setActiveState( boolean state )
   {
		is_Active = state;
	}

    public  boolean getActiveState()
    {
      return  is_Active;
    }

    public  boolean  isAlive()
    {
      return   itsThread.isAlive();
    }

    public void    stopServer()
    {
      System.out.println( "Stopping the server!" );  // The chances are it timed out...
      setActiveState( false );
    }

    public  void    restartServer()
    {
        notify();
    }

   public  void    closeServerConnection()
   {
      System.out.println( "Closing the server socket!" );  // The chances are it timed out...
      setActiveState( false );
      try
      {
         if( itsServerSocket != null )
         {
            itsServerSocket.close();
            itsServerSocket = null;
            itsThread = null;
         }
      }
      catch( IOException e )
      {
         e.printStackTrace();
      }
   }
}
